#include "graphapp.h"
#include <stdlib.h>
#include <grx20.h>

GrColor _currentcolour;
GrLineOption _currentoption;

rect insetr(rect r, int n) {
	rect r2;

	r2.x = r.x + n;
	r2.y = r.y + n;
	r2.width = r.width - n - n;
	r2.height = r.height - n - n;

	return(r2);

}

void fillrect(rect r) {
	GrFilledBox(r.x, r.y, r.x + r.width, r.y + r.height, _currentcolour);
}

void init() {
	//GrSetMode(GR_default_graphics);
	GrSetMode(GR_width_height_color_graphics, 800, 600, 16L << 20);
	GrClearScreen(GrWhite());
	_currentcolour = GrBlack();
	_currentoption.lno_width = 1;
	_currentoption.lno_color = _currentcolour;
	_currentoption.lno_pattlen = 0;
}

void setcolour(GrColor c) {
	int r, g, b;

	r = (c >> 16) & 0xFF;
	g = (c >> 8) & 0xFF;
	b = c & 0xFF;

	_currentcolour = GrAllocColor(r, g, b);
	_currentoption.lno_color = _currentcolour;
}

void setlinewidth(int w) {
	_currentoption.lno_width = w;
}

void fillellipse(rect r) {
	GrFilledEllipse(r.x + r.width/2, r.y + r.height/2, r.width/2, r.height/2,
			_currentcolour);
}

void drawarc(rect r, int start, int end) {
	GrCustomEllipseArc(r.x + r.width/2, r.y + r.height/2, r.width/2, r.height/2,
			start * 10, end * 10, 0, &_currentoption);
}

rect initrect(int x, int y, int w, int h) {
	rect r;

	r.x = x;
	r.y = y;
	r.width = w;
	r.height = h;
	return(r);
}

void drawpoint(point p) {
	GrPlot(p.x, p.y, _currentcolour);
}

void drawline(point p1, point p2) {
	GrCustomLine(p1.x, p1.y, p2.x, p2.y, &_currentoption);
}

void fillpolygon(point p[], int n) {
	int (*p2)[2];
	int i;

	p2 = malloc(2 * sizeof(int) * n);
	for (i=0; i<n; i++) {
		p2[i][0] = p[i].x;
		p2[i][1] = p[i].y;
	}

	GrFilledPolygon(n, p2, _currentcolour);
	free(p2);
}

point pt(int x, int y) {
	point p;
	
	p.x = x;
	p.y = y;
	return(p);
}

rgb initrgb(int r, int g, int b) {
	rgb colour;

	colour = ((long) r) << 16;
	colour |= ((long) g) << 8;
	colour |= b;

	return(colour);
}
