#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <pc.h>
#include <sys/movedata.h>
#include <dpmi.h>

#define randomize() (srand((unsigned) time(NULL)))

typedef unsigned char byte;

//prototypes
void plot(int x, int y, byte c);
void plasma(int x1, int y1, int x2, int y2);
void c2rgb(byte c, byte rgb[3]);
byte rgb2c(byte rgb[3]);
void randcolour(byte c[3], double a);

enum {
	swidth = 320,
	sheight = 200,
	picsize = 128,
	PALSIZE = 768
};

byte img[swidth * sheight];

int main() {
	byte c[3];
	int i, j;
	int addr;
	union REGS r;

	randomize();

	r.w.ax = 0x13;
	int86(0x10, &r, &r);

	outportb(0x3c8, 0);
	for (i=0; i<256; i++) {
		c2rgb(i, c);
		outportb(0x3c9, c[0]);
		outportb(0x3c9, c[1]);
		outportb(0x3c9, c[2]);
	}

	for (i=0; i<swidth * sheight; i++) img[i] = 0;

	img[0] = rand() % 256;
	img[picsize - 1] = rand() % 256;
	img[(picsize - 1) * swidth] = rand() % 256;
	img[(picsize - 1) * swidth + picsize - 1] = rand() % 256;
	/*
	img[0] = 3;
	img[picsize - 1] = 0xE0;
	img[(picsize - 1) * swidth] = 0;
	img[(picsize - 1) * swidth + picsize - 1] = 0x1C;
	*/
	plasma(0, 0, picsize-1, picsize-1);

	dosmemput(img, swidth * sheight, 0xA0000);

	getchar();
	printf("// Bitmap generated by plasma.c\n");
	printf("%d %d\n", picsize, picsize);
	for (i=0; i<picsize; i++) {
		for (j=0; j<picsize; j++) {
			printf("%d\n", img[i * swidth + j]);
		}
	}

	r.w.ax = 3;
	int86(0x10, &r, &r);

	return(0);
}

void plasma(int x1, int y1, int x2, int y2) {
	byte c11[3], c12[3];
	byte c21[3], c22[3];
	byte c[3];
	int xm, ym;
	int i;
	double xd;

	if (x2 - x1 <= 1 && y2 - y1 <= 1) return;
	c2rgb(img[y1 * swidth + x1], c11);
	c2rgb(img[y2 * swidth + x1], c12);
	//printf(": %d\n", c12[2]);
	c2rgb(img[y1 * swidth + x2], c21);
	c2rgb(img[y2 * swidth + x2], c22);

	xm = (x2 + x1) / 2;
	ym = (y2 + y1) / 2;

	xd = 1.0 * (x2 - x1) / picsize;
	xd *= xd;
	xd *= xd;
	xd *= 0.5;

	for (i=0; i<3; i++) c[i] = (c11[i] + c12[i] + c21[i] + c22[i]) / 4;
	randcolour(c, xd);
	plot(xm, ym, rgb2c(c));

	if (ym > y1) {
		for (i=0; i<3; i++) c[i] = (c11[i] + c12[i]) / 2;
		randcolour(c, xd);
		plot(x1, ym, rgb2c(c));
		for (i=0; i<3; i++) c[i] = (c21[i] + c22[i]) / 2;
		randcolour(c, xd);
		plot(x2, ym, rgb2c(c));
	}
	if (xm > x1) {
		for (i=0; i<3; i++) c[i] = (c11[i] + c21[i]) / 2;
		randcolour(c, xd);
		plot(xm, y1, rgb2c(c));
		for (i=0; i<3; i++) c[i] = (c12[i] + c22[i]) / 2;
		randcolour(c, xd);
		plot(xm, y2, rgb2c(c));
	}

	plasma(x1, y1, xm, ym);
	plasma(xm, y1, x2, ym);
	plasma(x1, ym, xm, y2);
	plasma(xm, ym, x2, y2);
}

void c2rgb(byte c, byte rgb[3]) {
	rgb[0] = ((c & 0xE0) >> 2) + 7;
	rgb[1] = ((c & 0x1C) << 1) + 7;
	rgb[2] = ((c & 0x3) << 4) + 15;
}

byte rgb2c(byte rgb[3]) {
	byte c;

	c = ((rgb[0] & 0x38) << 2) + ((rgb[1] & 0x38) >> 1) + (rgb[2] >> 4);
	//printf("%d %d %d -> %d\n", rgb[0], rgb[1], rgb[2], c);
	return(c);
}

void randcolour(byte c[3], double a) {
	int i, temp[3];

	temp[0] = c[0];
	temp[1] = c[1];
	temp[2] = c[2];

	for (i=0; i<= 64 * a; i++) {
		temp[0] += rand() % 3 - 1;
		temp[1] += rand() % 3 - 1;
		temp[2] += rand() % 5 - 2;
	}

	if (temp[0] < 0) temp[0] = 0;
	if (temp[1] < 1) temp[1] = 1;
	if (temp[2] < 2) temp[2] = 2;

	if (temp[0] > 63) temp[0] = 63;
	if (temp[1] > 63) temp[1] = 63;
	if (temp[2] > 63) temp[2] = 63;

	c[0] = (byte) temp[0];
	c[1] = (byte) temp[1];
	c[2] = (byte) temp[2];
}

void plot(int x, int y, byte c) {
	img[y * swidth + x] = c;
}
