/* Stage 2 of Task 2
   Ben Lin
   
   It might be easier if I preprocess all the info so the faces always
   look like 0 1 1 2 2 3 3 0 or something - plus I get to check for errors
   */


#include <stdio.h>
#include <stdlib.h>
#include "graphapp.h"

struct sceneinfo {
	double eye[3];
	double at[3];
	double up[3];
	double focal;
	double wwidth;
	double wheight;
	int swidth;
	int sheight;
};

struct facestruct {
	//struct objstruct *o;	// owner
	int ecount;
	int (*e)[2];
	double n[3];
	double colour[3];
	double diffuse, spec;
	int specpower;

	//	extra info:
	int vmin;	// smallest-numbered vertex
};

struct objstruct {
	int vcount;			// no. of vertices
	//double (*v)[3];		// vertices
	int fcount;			// no. of faces
	struct facestruct *face;
};

struct ilist {
	struct ilist *next;
	int i;
};

struct lightstruct {
	double loc[3];	// location
	double colour[3];
};

void readin(char *, void *, char *);
void parsecomment(void);
void scanfill(struct objstruct *, struct facestruct *);
//void draw_scene(drawing, rect);
void draw_scene(void);
void loadfile(char *);

double amblight[3];
int lightcount;
int objcount;
int vcount;
struct sceneinfo s;
struct objstruct *o;
struct lightstruct *light;
double (*vertex)[3];

FILE *infile;

int main(int argc, char **argv) {

#if 0
	window w;
	drawing d;
#endif

	loadfile("tt");

#if 0
	w = newwindow("Stage1", rect(50,50,s.swidth,s.sheight), StandardWindow);
	d = newdrawing(rect(0,0,s.swidth,s.sheight), draw_scene);
	setdata(w, d);	/* store the pointer with the window */

	show(w);
	mainloop();
#endif
	getchar();
	init();
	draw_scene();
	getchar();

	return(0);
}

/* Parse a .gen file */

void loadfile(char *filename) {
	int i, j, k;
	int v;
	int n;
	double f;

	if (!(infile = fopen(filename, "r"))) {
			perror("fopen");
			exit(1);
	}

	readin("%lf", &s.eye[0], "eye x");
	readin("%lf", &s.eye[1], "eye y");
	readin("%lf", &s.eye[2], "eye z");
	readin("%lf", &s.at[0], "view at x");
	readin("%lf", &s.at[1], "view at y");
	readin("%lf", &s.at[2], "view at z");
	readin("%lf", &s.up[0], "view up x");
	readin("%lf", &s.up[1], "view up y");
	readin("%lf", &s.up[2], "view up z");
	readin("%lf", &s.focal, "focal length");
	readin("%lf", &s.wwidth, "window width");
	readin("%lf", &s.wheight, "window height");
	readin("%d", &s.swidth, "screen height");
	readin("%d", &s.sheight, "screen height");

	readin("%lf", &amblight[0], "ambient light r");
	readin("%lf", &amblight[1], "ambient light g");
	readin("%lf", &amblight[2], "ambient light b");

	readin("%d", &lightcount, "number of lights");

	light = (struct lightstruct *) malloc(sizeof(struct lightstruct) * lightcount);

	for (i=0; i<lightcount; i++) {
		readin("%lf", &light[i].loc[0], "light x");
		readin("%lf", &light[i].loc[1], "light y");
		readin("%lf", &light[i].loc[2], "light z");

		readin("%lf", &light[i].colour[0], "light r");
		readin("%lf", &light[i].colour[1], "light g");
		readin("%lf", &light[i].colour[2], "light b");
	}

	readin("%d", &objcount, "number of objects");
	o = (struct objstruct *) malloc(sizeof(struct objstruct) * objcount);

	readin("%d", &vcount, "total vertices");
	vertex = (double (*)[3]) malloc(sizeof(double) * 3 * vcount);
	v = 0;

	for (i=0; i<objcount; i++) {

		readin("%d", &o[i].vcount, "number of vertices in object");

		//o[i].v = (double (*)[3]) malloc(sizeof(double) * 3 * o[i].vcount);
		for (j=0; j<o[i].vcount; j++) {
			readin("%lf", &vertex[v][0], "vertex x");
			readin("%lf", &vertex[v][1], "vertex y");
			readin("%lf", &vertex[v][2], "vertex z");
			v++;
		}

		readin("%d", &o[i].fcount, "number of faces");
		o[i].face = (struct facestruct *) malloc(sizeof(struct facestruct) * o[i].fcount);
		
		printf("object %d\n", i);
		for (j=0; j<o[i].fcount; j++) {
			printf("\tface %d\n", j);
			/* Memory inefficient - may change to linked list eventually
			 * (no. of edges <= no. of vertices)
			 */
			o[i].face[j].e = (int (*)[2]) malloc(sizeof(int) * 2 * o[i].vcount);

			o[i].face[j].vmin = o[i].vcount;
			k = 0;
			do {
				readin("%d", &n, "edge's from-vertex");

				if (n != -1) {
					if (o[i].face[j].vmin > n) o[i].face[j].vmin = n;
					o[i].face[j].e[k][0] = v - o[i].vcount + n;
					readin("%d", &n, "edge's to-vertex");
					if (o[i].face[j].vmin > n) o[i].face[j].vmin = n;
					o[i].face[j].e[k][1] = v - o[i].vcount + n;
					k++;
				}
			} while (n != -1);
			o[i].face[j].ecount = k;

			/* Renumber consistently */
			for (k=0; k<o[i].face[j].ecount; k++) {
				if ((o[i].face[j].e[k][0] > o[i].face[j].e[k][1])
						&& (o[i].face[j].e[k][1] != o[i].face[j].vmin)) {
					n = o[i].face[j].e[k][1];
					o[i].face[j].e[k][1] = o[i].face[j].e[k][0];
					o[i].face[j].e[k][0] = n;
				}
			}

			readin("%lf", &o[i].face[j].n[0], "normal x");
			readin("%lf", &o[i].face[j].n[1], "normal y");
			readin("%lf", &o[i].face[j].n[2], "normal z");

			/* Colour */
			readin("%lf", &o[i].face[j].colour[0], "face r");
			readin("%lf", &o[i].face[j].colour[1], "face g");
			readin("%lf", &o[i].face[j].colour[2], "face b");

			/* Diffuse, spec(ular), spec. power */
			readin("%lf", &o[i].face[j].diffuse, "diffuse");
			readin("%lf", &o[i].face[j].spec, "specular");
			readin("%d", &o[i].face[j].specpower, "specular power");

		}

	}

}

//void draw_scene(drawing d, rect r) {
void draw_scene(void) {
	int i, j;

	setcolour(Black);
	fillrect(initrect(0, 0, s.swidth, s.sheight));

	for (i=0; i<objcount; i++) {
		for (j=0; j<o[i].fcount; j++) {
			scanfill(&o[i], &o[i].face[j]);
		}
	}
}

void scanfill(struct objstruct *o, struct facestruct *f) {
	int i, j;
	int ymin, ymax;
	int max;
	int (*sv)[2];	// Screen coords of vertices
	char *dir;	// Records type of vertex - peak or not
	struct ilist *inter, *ip, *temp;
	int error;
	int x, y, dx, dy, x2, y2;
	int endx, endy;

	setcolour(initrgb((int) f->colour[0] * 255, (int) f->colour[1] * 255, (int) f->colour[2] * 255));

	sv = (int (*)[2]) malloc(sizeof(int) * 2 * vcount);
	dir = (char *) malloc(sizeof(char) * vcount);

	for (i=0; i<vcount; i++) {
		dir[i] = 0;
		sv[i][0] = (int) vertex[i][0];
		sv[i][1] = (int) vertex[i][1];
	}

	/* Find min, max y coords */
	ymax = ymin = sv[f->e[0][0]][1];
	for (i=0; i<f->ecount; i++) {
		if (ymax < sv[f->e[i][0]][1]) {
			ymax = sv[f->e[i][0]][1];
		}
		if (ymin > sv[f->e[i][0]][1]) {
			ymin = sv[f->e[i][0]][1];
		}
	}

	max = ymax - ymin + 1;
	inter = (struct ilist *) malloc(sizeof(struct ilist) * max);
	for (i=0; i<max; i++) {
		inter[i].next = NULL;
	}

	/* Calculate intersections */

/*
	for (i=0; i<o[0].ecount[0]; i++) {
		printf("%d - %d\n", o[0].e[0][i][0], o[0].e[0][i][1]);
	}
	printf("%d %d %d\n", vmin, ymin, ymax);
*/

	/*
	for (i=0; i<f->ecount; i++) {
		drawline(pt(sv[f->e[f][i][0]][0], sv[o->e[i][0]][1]),
				pt(sv[f->e[f][i][1]][0], sv[o->e[i][1]][1]));
	}
	*/
	for (i=0; i<f->ecount; i++) {
		x = sv[f->e[i][0]][0];
		y = sv[f->e[i][0]][1];
		endx = sv[f->e[i][1]][0];
		endy = sv[f->e[i][1]][1];
		drawline(pt(x, y), pt(endx, endy));
		//printf("%d %d, %d %d", x, y, endx, endy);
		dx = endx - x;
		dy = endy - y;
		if (dx > 0) x2 = 1;
		else {
			dx = -dx;
			x2 = -1;
		}
		if (dy > 0) {
			y2 = 1;
		} else {
			dy = -dy;
			y2 = -1;
		}

		if (dy) {
			dir[f->e[i][0]] += y2;
			dir[f->e[i][1]] -= y2;
			error = dy;
			if (error > 0) error = -error;
			error /= 2;
			y-=ymin;
			endy-=ymin;
			do {

				if (!inter[y].next) {
					inter[y].next = (struct ilist *) malloc(sizeof(struct ilist));
					inter[y].next->i = x;
					inter[y].next->next = NULL;
				} else {
					ip = &inter[y];
					while (ip->next && ip->next->i < x)
						ip = ip->next;

					temp = ip->next;
					ip->next = (struct ilist *) malloc(sizeof(struct ilist));
					ip->next->i = x;
					ip->next->next = temp;
				}

				y += y2;

				error += dx;
				while (error > 0) {
					x += x2;
					error -= dy;
				}
			} while(y != endy);

			/* Must decide whether to include this vertex or not */

			/* More efficient if I duplicate code ? */
				if (!inter[y].next) {
					inter[y].next = (struct ilist *) malloc(sizeof(struct ilist));
					inter[y].next->i = x;
					inter[y].next->next = NULL;
				} else {
					ip = &inter[y];
					while (ip->next && ip->next->i < x)
						ip = ip->next;

					temp = ip->next;
					ip->next = (struct ilist *) malloc(sizeof(struct ilist));
					ip->next->i = x;
					ip->next->next = temp;
				}

		}
	}

	for(i=0; i<f->ecount; i++) {
		/* get vertex number of from-vertex of this edge */
		j = f->e[i][0];
		if (!dir[j]) {
			/* Must remove a vertex in this case */
			y = sv[j][1] - ymin;
			ip = &inter[y];
			while (ip->next->i != sv[j][0]) ip = ip->next;
			temp = ip->next->next;
			free(ip->next);
			ip->next = temp;
		}

	}

	/* Draw the scan lines */
	for(i=0; i<max; i++) {
		ip = &inter[i];
		while (ip->next) {
			ip = ip->next;
			x = ip->i;
			if (!ip->next) continue;
			ip = ip->next;
			x2 = ip->i;
			//printf("%d %d\n", x, x2);
			drawline(pt(x, i + ymin), pt(x2, i + ymin));
		}
	}

	free(sv);
}

void readin(char *s, void *f, char *thing) {
	char done;
	int check;
	char ch;

	done = 0;
	do {
		fscanf(infile, " %c", &ch);
		if (ch == '/') {
			parsecomment();
		} else {
			ungetc(ch, infile);
			check = fscanf(infile, s, f);
			if (!check) {
				fprintf(stderr, "Error reading %s\n", thing);
				exit(1);
			}
			//printf("Read %s\n", thing);
			done++;
		}
	} while (!done);
}

void parsecomment(void) {
	char ch;
	char flag;

	if ((ch = getc(infile)) != '*') {
		fprintf(stderr, "Warning: bad comment\n");
	}
	flag = 0;
	do {
		do {
			ch = getc(infile);
		} while (ch != '*');
		if ((ch = getc(infile)) == '/') {
			flag++;
		}
	} while (!flag);
}
